%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% INSTITUTO TECNOLGICO DE AERONUTICA
% MPS-43
% Projeto de um servocontrolador com estados observados, por alocao de 
% polos, para a aerogangorra, sem mola
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Autor: Davi A. Santos
% Data: 18/11/2019
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clc;
clear;

%% Dados
l = 0.2; J = 0.1; % do modelo
f = 1;
sc1=-2;           % especificaes
sc2=-2;
so1=-10;
so2=-10;


%% Modelo em espao de estados
A = [0 1;0 0];
B = [0;l/J];
C = [1 0];


%% Projeto do Controlador

% 1. Verificao da controlabilidade
C_ = [B A*B];
if rank(C_) == 2,
    'A realizao (A,B)  completamente controlvel'
else
    'A realizao (A,B) no  controlvel'
end

% 2. Matriz de transformao para a forma cannica controlvel
W = [-A(2,2) 1;1 0];
P = C_*W;

% 3. Coeficientes do polinmio caracterstico de malha aberta
a0 = -A(2,1);
a1 = -A(2,2);

% 4. Coeficientes do polinmio caracterstico desejado
alfa0 = sc1*sc2;
alfa1 = -(sc1+sc2);

% 5. Clculo da matriz de ganhos de realimentao
K = [alfa0-a0,alfa1-a1]*inv(P);

% 6. Clculo de N
N = -1/(C*inv(A-B*K)*B);

%% Projeto do observador (Mtodo 1)

% 1. Verificao da observabilidade
O = [C; C*A];
if rank(O) == 2,
    'A realizao (A,C)  completamente observvel'
else
    'A realizao (A,C) no  observvel'
end

% 2. Matriz de transformao para a forma cannica observvel
%W = [-A(2,2) 1;1 0];  a mesma
Q = inv(W*O);

% 3. Coeficientes do polinmio caracterstico de malha aberta
%a0 = -A(2,1);  so os mesmos de l de cima
%a1 = -A(2,2);

% 4. Coeficientes do polinmio caracterstico desejado
alfa0 = so1*so2;
alfa1 = -(so1+so2);

% 5. Clculo da matriz de ganhos do observador
L = Q*[alfa0-a0;alfa1-a1];



%% Resultados
K
N
L


